#2229 closed defect (fixed)

Network stack semaphore claim/release not protected for direct SCORE access.

Reported by: Chris Johns Owned by: Chris Johns
Priority: highest Milestone: 4.11
Component: network/legacy Version: 4.11
Severity: critical Keywords: networking
Cc: Blocked By:
Blocking:

Description

The network semaphore is currently built with RTEMS_FAST_MUTEX and a network semaphore claim or release results in a crash because the pointer to the internal SCORE mutex is not check in the claim or release. A check should be made for NULL to avoid this invalid access.

This access is an API violation as the SCORE is being directly accessed. It is too late in the 4.11 release cycle to change this and the stack is too old to be concerned about correcting this. This ticket is not about the access violation.

Attachments (2)

Change History (8)

comment:1 Changed on Dec 22, 2014 at 3:51:19 PM by Gedare Bloom

Please keep the prevailing style of the edited file.

Should this be back-ported to 4.10 and 4.9 release branches?

comment:2 Changed on Dec 22, 2014 at 9:12:02 PM by Chris Johns

White space (tab vs spaces) or something else ?

comment:3 Changed on Dec 22, 2014 at 9:16:56 PM by Gedare Bloom

I only noticed the white spaces.

comment:4 Changed on Dec 22, 2014 at 9:58:39 PM by Chris Johns

Thanks. I will regenerate.

comment:5 Changed on Feb 1, 2015 at 11:21:04 PM by Ben Gras

i just noticed this ticket, i've seen this problem too and thought i'd pitch in.

comment:6 Changed on Feb 24, 2015 at 5:53:42 PM by Chris Johns <chrisj@…>

Resolution: fixed
Status: newclosed

In ee87007748e44aeedad7cbb6a4465714a323961c/rtems:

Panic on RTEMS_FAST_MUTEX network semaphore claim/release.

Fix the code to panic rather than perform a bad access if the network
semaphore is accessed without the stack being intialised.

Closes #2229.

Note: See TracTickets for help on using tickets.